#ifndef LOCKDOWN_EXECUTER_HPP
#define LOCKDOWN_EXECUTER_HPP

#include <string>
#include <map>
#include <list>

#include "lockdown.hpp"

class lockdown::Executer {
	//First string = filname, second string = options
	std::multimap<std::string, std::string> files;		//the "path" options
	//First string = login class, second string = options
	std::multimap<std::string, std::string> loginClass;	//the login_class options
	std::list<std::string> kernel;		//the kern options
	std::list<std::string> mount;		//the mount options
	std::map<std::string, std::string> defines;	//the define options
	std::list<std::string> file;	//the file options
	
	std::list<std::string> settings;	//The conf file
	std::list<std::string>::iterator settingReader;
	Executer() {}
	void define();
	void writeText();
	void defineProcesser();
	void rootLogin(const std::string& options);
	public:
	static Executer* inst() {
		static lockdown::Executer* myself = new Executer;
		return myself;
	}
	void execute();
};

#endif
