#ifndef LOCKDOWN_IO_FILE_HPP
#define LOCKDOWN_IO_FILE_HPP

#include <string>
#include <list>

#include <sys/stat.h>

#include "../io.hpp"
#include "IOException.hpp"

class lockdown::io::File  {
	struct stat fileInfo;
	std::string filename;
	public:          
	class OpenError : public IOException {
		public:
		OpenError(const std::string& m) : IOException(m) {}
	};
	class ReadError : public IOException {
		public:
		ReadError(const std::string& m) : IOException(m) {}
	};
	class WriteError : public IOException {
		public:
		WriteError(const std::string& m) : IOException(m) {}
	};
	class PermissionError : public IOException {
		public:
		PermissionError(const std::string& m) : IOException(m) {}
	};
	class NotFoundError : public IOException {
		public:
		NotFoundError(const std::string& m) : IOException(m) {}
	};
			 
	File(const std::string& file, bool createIfNotFound = false);
	void read(std::list<std::string>& readTo);
	void write(const std::list<std::string>& writeFrom);
	void setPermissions(std::string& perms);
	void setUser(const std::string& user);
	void setGroup(const std::string& group);
	void setFlags(const std::string& flags);
};				

#endif
