#include "Output.hpp"
#include "OutputBase.hpp"
#include "Stdout.hpp"
#include "Syslog.hpp"

using namespace lockdown::io::out;

Output::Output() : out(0),  verbose_(false) {}

Output::~Output() { delete out; }

void Output::write(Type t, const std::string& message) {
	if(out == 0)
		useStdout();
	if(t == INFO && verbose_ == false)
		return;
	out->write(t, message);
}

Output* Output::inst() {
	static Output* myself = new Output;
	return myself;
}

void Output::useStdout() {
	OutputBase *ob = new Stdout;
	delete out;
	out = ob;
}

void Output::useSyslog(const std::string& programname) {
	OutputBase *ob = new Syslog(programname);
	delete out;
	out = ob;
}
