#ifndef LOCKDOWN_IO_OUT_SYSLOG_HPP
#define LOCKDOWN_IO_OUT_SYSLOG_HPP

#include <string>

#include <syslog.h>
#include <stdarg.h>

#include "../out.hpp"
#include "Output.hpp"
#include "OutputBase.hpp"

class lockdown::io::out::Syslog : public lockdown::io::out::OutputBase {
	public:
	Syslog(const std::string& programName) {
		openlog(programName.c_str(), LOG_CONS, LOG_USER);
	}
	
	void write(lockdown::io::out::Output::Type t, const std::string& message) {
		if(t == lockdown::io::out::Output::ERROR)
					syslog(LOG_ERR, message.c_str());
		else
					syslog(LOG_INFO, message.c_str());
	}
	
	~Syslog() { closelog(); }
};

#endif
