/*	'modify' can handle list's with the
	following syntax:
	word1 word2
	word1=word2
	word1
	If word1 from 'changes' is not
	found in 'current', it will be added.
	If it is found, word2 will be changed according
	to the second string in 'changes'
*/

#include <list>
#include <string>
#include <sstream>

#include "../modifiers.hpp"

using namespace std;

void lockdown::modifiers::modify(listS& current, listS& changes) {
	listS::iterator currentReader;
	for(currentReader = current.begin();currentReader != current.end(); currentReader++) {
		if(*currentReader == "" || (*currentReader).at(0) == '#')
			continue;
		string keyword;
		stringstream ss;
		ss<<*currentReader;
		ss>>keyword;
		string::size_type pos = keyword.find('=');
		if(pos != string::npos)
			keyword.erase(pos, keyword.size() - pos);
		
		listS::iterator changeReader;
		for(changeReader = changes.begin();changeReader != changes.end(); changeReader++) {
			stringstream tt;
			string keyword2;
			tt<<*changeReader;
			tt>>keyword2;
			string::size_type pos = keyword2.find('=');
			if(pos != string::npos)
				keyword2.erase(pos, keyword2.size() - pos);
			
			if(keyword2 == keyword) {
				string comment = "";
				string::size_type p = (*currentReader).find('#');
				if(p != string::npos)
					comment = (*currentReader).substr(p, (*currentReader).size() - p);
				if(comment != "")
					*currentReader += '\t' + comment;	
				*currentReader = *changeReader;
				changes.erase(changeReader);
				break;
			}
		}
	}
	
	//Add options that was not already in the list
	listS::const_iterator changeReader = changes.begin();
	for(;changeReader != changes.end();changeReader++) 
		current.push_back(*changeReader);
}
