/*	'modifyKernel' is for adding options
		to the kernel fil
*/

#include <list>
#include <string>
#include <sstream>

#include "../SyntaxErrorException.hpp"
#include "../modifiers.hpp"

using namespace std;

void lockdown::modifiers::modifyKernel(listS& current, listS& changes) {
	listS::iterator currentReader = current.begin();
	for(;currentReader != current.end(); currentReader++) {
		if(*currentReader == "" || (*currentReader).at(0) == '#')
			continue;
		string keyword1;
		string keyword2;
		stringstream ss;
		ss<<*currentReader;
		ss>>keyword1;
		ss>>keyword2;
		if(!ss)
			throw SyntaxErrorException("Kernel file missing a second parameter at: " + keyword1);
		
		list<string>::iterator changeReader;
		for(changeReader = changes.begin();changeReader != changes.end(); changeReader++) {
			stringstream tt;
			tt<<*changeReader;
			string key1;
			string key2;
			tt>>key1;
			tt>>key2;
			if(!tt)
				throw SyntaxErrorException("Kernel option missing a second parameter at: " + key1);
			if(keyword1 == key1 && keyword2 == key2) {	//It is already there
				changes.erase(changeReader);
				break;
			}
		}
	}
	
	//Kernel options not already in the kernel
	listS::iterator changeReader = changes.begin();
	for(;changeReader != changes.end();changeReader++) {
		(*changeReader).replace((*changeReader).find(" "), 1, "\t\t");
		current.push_back(*changeReader);
	}
}
