/*	'modifyMount' is for adding options
		to the fstab file
*/

#include <list>
#include <string>
#include <sstream>

#include "../SyntaxErrorException.hpp"
#include "../modifiers.hpp"

using namespace std;

void lockdown::modifiers::modifyMount(listS& current, listS& changes) {
	listS::iterator currentReader = current.begin();
	for(;currentReader != current.end(); currentReader++) {
		if(*currentReader == "" || (*currentReader).at(0) == '#')
			continue;
		string mountpoint;
		string perms;
		stringstream ss;
		ss<<*currentReader;
		ss>>mountpoint;		//Skip one
		ss>>mountpoint;
		ss>>perms;				//Skip one again
		ss>>perms;
		if(!ss) 
			throw SyntaxErrorException("Mount file format error at: " + mountpoint);
		
		listS::const_iterator changeReader = changes.begin();
		for(changeReader = changes.begin();changeReader != changes.end(); changeReader++) {
			stringstream tt;
			tt<<*changeReader;
			string mountpoint2;
			string perms2;
			tt>>mountpoint2;
			tt>>perms2;
			if(!tt)
				throw SyntaxErrorException("Mount option missing a second paramter: " + mountpoint2);
			if(mountpoint == mountpoint2) {
				(*currentReader).replace((*currentReader).find(perms), perms.size(), perms2);
				break;
			}
		}
	}
}
